package dev.shadowsoffire.apotheosis.adventure.compat;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.mojang.datafixers.kinds.App;
import com.mojang.datafixers.kinds.Applicative;
import com.mojang.serialization.Codec;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import dev.shadowsoffire.apotheosis.adventure.AdventureModule;
import dev.shadowsoffire.apotheosis.adventure.compat.GameStagesCompat;
import dev.shadowsoffire.apotheosis.adventure.compat.GatewaysCompat;
import dev.shadowsoffire.apotheosis.adventure.loot.AffixLootEntry;
import dev.shadowsoffire.apotheosis.adventure.loot.AffixLootRegistry;
import dev.shadowsoffire.apotheosis.adventure.loot.LootController;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.apotheosis.adventure.loot.RarityRegistry;
import dev.shadowsoffire.gateways.entity.GatewayEntity;
import dev.shadowsoffire.gateways.gate.Reward;
import dev.shadowsoffire.placebo.reload.DynamicHolder;
import dev.shadowsoffire.placebo.reload.WeightedDynamicRegistry;
import java.util.function.Consumer;
import java.util.function.Function;
import java.util.function.Predicate;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.Level;

public final class RarityAffixItemReward extends Record implements Reward {
  private final DynamicHolder<LootRarity> rarity;
  
  public static Codec<RarityAffixItemReward> CODEC;
  
  public RarityAffixItemReward(DynamicHolder<LootRarity> rarity) {
    this.rarity = rarity;
  }
  
  public final String toString() {
    // Byte code:
    //   0: aload_0
    //   1: <illegal opcode> toString : (Ldev/shadowsoffire/apotheosis/adventure/compat/GatewaysCompat$RarityAffixItemReward;)Ljava/lang/String;
    //   6: areturn
    // Line number table:
    //   Java source line number -> byte code offset
    //   #91	-> 0
    // Local variable table:
    //   start	length	slot	name	descriptor
    //   0	7	0	this	Ldev/shadowsoffire/apotheosis/adventure/compat/GatewaysCompat$RarityAffixItemReward;
  }
  
  public final int hashCode() {
    // Byte code:
    //   0: aload_0
    //   1: <illegal opcode> hashCode : (Ldev/shadowsoffire/apotheosis/adventure/compat/GatewaysCompat$RarityAffixItemReward;)I
    //   6: ireturn
    // Line number table:
    //   Java source line number -> byte code offset
    //   #91	-> 0
    // Local variable table:
    //   start	length	slot	name	descriptor
    //   0	7	0	this	Ldev/shadowsoffire/apotheosis/adventure/compat/GatewaysCompat$RarityAffixItemReward;
  }
  
  public final boolean equals(Object o) {
    // Byte code:
    //   0: aload_0
    //   1: aload_1
    //   2: <illegal opcode> equals : (Ldev/shadowsoffire/apotheosis/adventure/compat/GatewaysCompat$RarityAffixItemReward;Ljava/lang/Object;)Z
    //   7: ireturn
    // Line number table:
    //   Java source line number -> byte code offset
    //   #91	-> 0
    // Local variable table:
    //   start	length	slot	name	descriptor
    //   0	8	0	this	Ldev/shadowsoffire/apotheosis/adventure/compat/GatewaysCompat$RarityAffixItemReward;
    //   0	8	1	o	Ljava/lang/Object;
  }
  
  public DynamicHolder<LootRarity> rarity() {
    return this.rarity;
  }
  
  static {
    CODEC = RecordCodecBuilder.create(inst -> inst.group((App)RarityRegistry.INSTANCE.holderCodec().fieldOf("rarity").forGetter(RarityAffixItemReward::rarity)).apply((Applicative)inst, dev.shadowsoffire.apotheosis.adventure.compat.GatewaysCompat.RarityAffixItemReward::new));
  }
  
  public void generateLoot(ServerLevel level, GatewayEntity gate, Player summoner, Consumer<ItemStack> list) {
    AffixLootEntry entry = (AffixLootEntry)AffixLootRegistry.INSTANCE.getRandomItem(level.f_46441_, summoner.m_36336_(), new Predicate[] { WeightedDynamicRegistry.IDimensional.matches((Level)level), GameStagesCompat.IStaged.matches(summoner) });
    if (entry == null) {
      AdventureModule.LOGGER.error("Failed to find an affix loot item for a RarityAffixItemReward executing in dimension {} with rarity {}.", level.m_46472_(), this.rarity.getId());
      return;
    } 
    list.accept(LootController.createLootItem(entry.getStack(), (LootRarity)this.rarity.get(), level.f_46441_));
  }
  
  public void appendHoverText(Consumer<MutableComponent> list) {
    list.accept(Component.m_237110_("reward.apotheosis.affix", new Object[] { ((LootRarity)this.rarity.get()).toComponent() }));
  }
  
  public Codec<? extends Reward> getCodec() {
    return (Codec)CODEC;
  }
}
